//+------------------------------------------------------------------+
//|                                       Forex trend scalpingM5.mq4 |
//|                                     fxfariz a.k.a warrior trader |
//|                                                fxfariz@gmail,com |
//+------------------------------------------------------------------+
#property copyright "fxfariz a.k.a warrior trader"
#property link      "fxfariz@gmail,com"

#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Aqua
#property  indicator_color2  Red
#property  indicator_color3  Black
#property indicator_width1 5
#property indicator_width2 5
#property indicator_width3 2
#property indicator_level1 0
#property indicator_levelcolor clrBlack
#property indicator_levelstyle STYLE_DOT

extern ENUM_TIMEFRAMES TimeFrame = PERIOD_CURRENT;
extern int    Periodos = 21;

extern bool   AlertsOn        = true;
extern bool   AlertsOnCurrent = true;
extern bool   AlertsMessage   = true;
extern bool   AlertsSound     = false;
extern bool   AlertsEmail     = false;

extern bool   ShowLines       = true;
extern color  LineUpColor     = Blue;
extern color  LineDnColor     = Red;
extern ENUM_LINE_STYLE LinesStyle = STYLE_DASH;
extern int    LinesWidth      = 1;
extern string AlertSound      ="alert2";
extern string SignalName      ="Forex trend";
extern int    CrossBarsSeen   = 200;

double TrendBuffer[];
double ExtBuffer1[];
double ExtBuffer2[];
double arrup[],arrdwn[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    maxArrows;

//-------------------------------

int init()
  {
   IndicatorBuffers(5);
   SetIndexBuffer(0,ExtBuffer1);SetIndexLabel(0,"Trend Up");
   SetIndexBuffer(1,ExtBuffer2);SetIndexLabel(1,"Trend Down");
   SetIndexBuffer(2,TrendBuffer);SetIndexLabel(2,"Trend Line");
   SetIndexBuffer(3,arrup);
   SetIndexBuffer(4,arrdwn);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_LINE);
   IndicatorDigits(Digits+1);
   
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame==-99;
   TimeFrame         = MathMax(TimeFrame,_Period);
         
   IndicatorShortName(timeFrameToString(TimeFrame)+" Forex trend ("+Periodos+")");
   return(0);
  }

//-------------------------------------------------------------------

int deinit() {if (ShowLines) DeleteArrows();return(0);}

//-------------------------------------------------------------------

int start()
  {
   double Value=0,Value1=0,Value2=0,Fish=0,Fish1=0,Fish2=0;
   double price,MinL=0,MaxH=0;
   
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   int i,limit=MathMin(Bars-counted_bars,Bars-1);
   if (returnBars) { TrendBuffer[0] = limit+1; return(0); }  

   if (TimeFrame!=Period())
       {
         limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
         for (i=limit; i>=0; i--)
            {
              int y = iBarShift(NULL,TimeFrame,Time[i]);  
              ExtBuffer1[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Periodos,AlertsOn,AlertsOnCurrent,AlertsMessage,AlertsSound,AlertsEmail,ShowLines,0,y);
              ExtBuffer2[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Periodos,AlertsOn,AlertsOnCurrent,AlertsMessage,AlertsSound,AlertsEmail,ShowLines,1,y);
              TrendBuffer[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Periodos,AlertsOn,AlertsOnCurrent,AlertsMessage,AlertsSound,AlertsEmail,ShowLines,2,y);             
            }
         return(0);
       }
            
            
   for(i=0; i<Bars; i++)
       {
         MaxH = High[Highest(NULL,0,MODE_HIGH,Periodos,i)];
         MinL = Low[Lowest(NULL,0,MODE_LOW,Periodos,i)];
         price = (High[i]+Low[i])/2;
         
         if(MaxH-MinL == 0) Value = 0.33*2*(0-0.5) + 0.67*Value1; 
         else Value = 0.33*2*((price-MinL)/(MaxH-MinL)-0.5) + 0.67*Value1;     
         
         Value=MathMin(MathMax(Value,-0.999),0.999); 
         
         if(1-Value == 0) TrendBuffer[i]=0.5+0.5*Fish1;
         else TrendBuffer[i]=0.5*MathLog((1+Value)/(1-Value))+0.5*Fish1;
         
         Value1=Value;
         Fish1=TrendBuffer[i];
                           
         if (TrendBuffer[i]<0) {ExtBuffer2[i]=TrendBuffer[i];ExtBuffer1[i]=EMPTY_VALUE;}
         if (TrendBuffer[i]>0) {ExtBuffer1[i]=TrendBuffer[i];ExtBuffer2[i]=EMPTY_VALUE;}
                  
         if (TrendBuffer[i]>0 && TrendBuffer[i+1]<0) arrup[i] =1;else arrup[i] =EMPTY_VALUE; 
         if (TrendBuffer[i]<0 && TrendBuffer[i+1]>0) arrdwn[i]=1;else arrdwn[i]=EMPTY_VALUE;
       }
   
   if (ShowLines)
            {
               DeleteArrows();
               for (i=0; i<CrossBarsSeen ;i++)
                  {
                     if (arrup[i]  != EMPTY_VALUE) DrawArrow(i,"up");
                     if (arrdwn[i] != EMPTY_VALUE) DrawArrow(i,"down");
                  }
            } 
                       
   manageAlerts();
   
   return(0);
  }
  
//-------------------------------------------------------------------

void DrawArrow(int i,string type)
{
   maxArrows++;
      string name  = StringConcatenate(SignalName,maxArrows);
               
      ObjectCreate(name,OBJ_VLINE,0,Time[i],0);
      
      if (type=="up")
         {
            ObjectSet(name,OBJPROP_STYLE,LinesStyle);    
            ObjectSet(name,OBJPROP_WIDTH,LinesWidth);    
            ObjectSet(name,OBJPROP_COLOR,LineUpColor);
         }
      else if (type=="down")
      
         {
            ObjectSet(name,OBJPROP_STYLE,LinesStyle);
            ObjectSet(name,OBJPROP_WIDTH,LinesWidth);
            ObjectSet(name,OBJPROP_COLOR,LineDnColor);
         }
}

//--------------------------------------------------------------------

void DeleteArrows()
{
   while(maxArrows>0) { ObjectDelete(StringConcatenate(SignalName,maxArrows));maxArrows--; }
}

//+-------------------------------------------------------------------

void manageAlerts()
{
   if (AlertsOn)
   {
      if (AlertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
         if (arrup[whichBar]  != EMPTY_VALUE) doAlert(whichBar," BUY Signal @ ");
         if (arrdwn[whichBar] != EMPTY_VALUE) doAlert(whichBar," SELL Signal @ ");
   }
}

//--------------------------------------------------------------------

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar])
    {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];
            
       message = timeFrameToString(TimeFrame)+" Forex trend "+Symbol()+doWhat+DoubleToStr(Close[0],Digits);
          if (AlertsMessage) Alert(message);
          if (AlertsEmail)   SendMail(StringConcatenate(Symbol(),"Forex trend "),message);
          if (AlertsSound)   PlaySound(AlertSound);
    }
}

//-------------------------------------------------------------------

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
//-------------------------------------------------------------------